'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _flow2 = require('lodash/flow');

var _flow3 = _interopRequireDefault(_flow2);

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FormField2 = require('./FormField');

var _FormField3 = _interopRequireDefault(_FormField2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = (_temp2 = _class = function (_FormField) {
  _inherits(Input, _FormField);

  function Input() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Input);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Input.__proto__ || Object.getPrototypeOf(Input)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (event) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          disabled = _this$props.disabled;

      if (disabled) return;
      if (onChange) onChange(_this._processValue(event.target.value), event);
    }, _this.focus = function () {
      return _this.skinParts[Input.SKIN_PARTS.INPUT].focus();
    }, _this.blur = function () {
      return _this.skinParts[Input.SKIN_PARTS.INPUT].blur();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Input, [{
    key: 'prepareSkinProps',
    value: function prepareSkinProps(props) {
      return Object.assign({}, _get(Input.prototype.__proto__ || Object.getPrototypeOf(Input.prototype), 'prepareSkinProps', this).call(this, props), {
        onChange: this.onChange
      });
    }
  }, {
    key: '_processValue',
    value: function _processValue(value) {
      return (0, _flow3.default)([this._enforceStringValue, this._enforceMaxLength]).call(this, value);
    }
  }, {
    key: '_enforceStringValue',
    value: function _enforceStringValue(value) {
      if (!(0, _isString3.default)(value)) throw 'Values passed to Input::onChange must be strings';
      return value;
    }
  }, {
    key: '_enforceMaxLength',
    value: function _enforceMaxLength(value) {
      var maxLength = this.props.maxLength;

      var isTooLong = maxLength != null && value.length > maxLength;
      return isTooLong ? value.substring(0, maxLength) : value;
    }
  }]);

  return Input;
}(_FormField3.default), _class.SKIN_PARTS = {
  INPUT: 'input'
}, _class.propTypes = Object.assign({}, _FormField3.default.propTypes, {
  value: _propTypes2.default.string,
  placeholder: _propTypes2.default.string,
  maxLength: _propTypes2.default.number,
  onKeyPress: _propTypes2.default.func,
  readOnly: _propTypes2.default.bool
}), _class.defaultProps = Object.assign({}, _FormField3.default.defaultProps, {
  value: ''
}), _temp2);
exports.default = Input;
//# sourceMappingURL=Input.js.map